/*
 * Trieda nacitava a zapisuje do xml suboru
 */
package parser;

/**
 *
 * @author johnyboss
 */
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import org.openide.util.Exceptions;
import org.w3c.dom.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
/*
 * Trieda nacitava a zapisuje do xml suboru
 */
public class ReadXml {

    private ArrayList<ArrayList> premenne = new ArrayList<ArrayList>();
    private ArrayList<String> koncovky = new ArrayList<String>();
     private ArrayList<Xml> xmlData = new ArrayList<Xml>();
    String CESTA = "typ.xml";
    private File subor;

/**
     * Konstruktor ktory nacita subor typ.xml
     */
    public ReadXml() {
        this.citajXml();
    }

    /**
     * Funkcia nacita subor typ.xml do potrebnych udajovych struktur
     */


    private void getPath(){
             File priecinok;
          String sep = System.getProperty("file.separator");
            String property = System.getProperty("os.name");
            if(property.equals("Linux")){

           priecinok = new File(".dsd_config");
            if(!priecinok.isDirectory())  priecinok.mkdir();
            String path = priecinok.getAbsolutePath();
            CESTA=path+sep+"typ.xml";
            }

            else{
               priecinok = new File("dsd_config");

            if(!priecinok.isDirectory())
            {
                priecinok.mkdir();
               priecinok.setWritable(true, false);
               priecinok.setReadable(true, false);
                }
            String path = priecinok.getAbsolutePath();
            CESTA=path+sep+"typ.xml";

             }
            subor= new File(CESTA);
         }

    private void citajXml() {
        try {
          getPath();
           DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
            Document doc;
            //nacita subor bud z adresara alebo zo resources
            
            if ((subor.exists())&&(subor.length()!=0)) {
                doc = docBuilder.parse(subor);
            } else {
                doc = docBuilder.parse(getResource());
            }

            doc.getDocumentElement().normalize();
            NodeList typy = doc.getElementsByTagName("typ");
            for (int s = 0; s < typy.getLength(); s++) {
                Xml xml=new Xml();
                String typ = typy.item(s).getAttributes().getNamedItem("name").getNodeValue();
                xml.setName(typ);
                //nacita koncovky
                Node polozka = typy.item(s);
                if (polozka.getNodeType() == Node.ELEMENT_NODE) {
                    Element slovo = (Element) polozka;

                    NodeList slov = slovo.getElementsByTagName("file");
                    int length2 = slov.getLength();
                    ArrayList<String> pooo = new ArrayList<String>();
                    for (int i = 0; i < length2; i++) {
                        String ss = slov.item(i).getAttributes().getNamedItem("value").getNodeValue();

                        pooo.add(ss);

                    }
                    //vytvori arraylist s slovami
                    xml.setKoncovky(pooo);


                    NodeList slovko = slovo.getElementsByTagName("word");
                    int length1 = slovko.getLength();
                    ArrayList<String> poo = new ArrayList<String>();
                    for (int i = 0; i < length1; i++) {
                        String ss = slovko.item(i).getAttributes().getNamedItem("value").getNodeValue();

                        poo.add(ss);

                    }
                    //vytvori arraylist s slovami
                    xml.setSlova(poo);
                }
xmlData.add(xml);
            }
        } catch (IOException ex) {
            Exceptions.printStackTrace(ex);
        } catch (ParserConfigurationException ex) {
            Exceptions.printStackTrace(ex);
        } catch (SAXParseException err) {
        } catch (SAXException e) {
            Exception x = e.getException();
            ((x == null) ? e : x).printStackTrace();

        }


    }//end of main
/**
     * Funkcia vracia zoznam slov pre dany typ suboru
     */
    public ArrayList<String> getPremenne(int i) {
        
        return xmlData.get(i).getSlova();

    }

    /**
     * Funkcia vracia zoznam typov suborov
     */
    public ArrayList<String> getKoncovky(int i) {
        return xmlData.get(i).getKoncovky();
    }
public ArrayList<String> getName() {
    ArrayList<String>pom =new ArrayList<String>();
    for (int i = 0; i < xmlData.size(); i++) {
        pom.add(xmlData.get(i).getName());

    }
        return pom;
    }
    /**
     * Funkcia vytvara Xml subor
     */
    private void zapisXml() {

        try {

            DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = docFactory.newDocumentBuilder();

            Document doc = docBuilder.newDocument();
            Element rootElement = doc.createElement("syntax");
            doc.appendChild(rootElement);
//uklada koncovky suborov
            for (int i = 0; i < xmlData.size(); i++) {
                Element typ = doc.createElement("typ");
                rootElement.appendChild(typ);
                String pom = xmlData.get(i).getName();
                typ.setAttribute("name", pom);

                //uklada jednotlive typy slov
                 for (int j = 0; j < xmlData.get(i).getKoncovky().size(); j++) {
                    String f = xmlData.get(i).getKoncovky().get(j);
                    Element polozka = doc.createElement("file");
                    polozka.setAttribute("value", f);
                    typ.appendChild(polozka);

                }
                for (int j = 0; j < xmlData.get(i).getSlova().size(); j++) {
                    String f = xmlData.get(i).getSlova().get(j);
                    Element polozka = doc.createElement("word");
                    polozka.setAttribute("value", f);
                    typ.appendChild(polozka);

                }

            }

            //zapisuje do suboru typ.xml
            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();
            transformer.setOutputProperty(OutputKeys.INDENT, "yes");
            DOMSource source = new DOMSource(doc);

            StreamResult result = new StreamResult(subor);
            transformer.transform(source, result);

        } catch (ParserConfigurationException pce) {
        } catch (TransformerException tfe) {
        }

    }
    /**
     * funkcia prida novy typ syntaxe do suboru
     */
    
    public void add(String name, ArrayList<String>koncovky, ArrayList<String>slova) {
        Xml pomxml=new Xml(name, koncovky, slova);
        xmlData.add(pomxml);
        zapisXml();
    }

    /**
     * @return the cesta
     */


    /**
     * Funkcia vracia InputStream resources
     */
    private InputStream getResource() {
       InputStream resource = getClass().getResourceAsStream("/resources/typ.xml");
        
        return resource;
    }

    /**
     * funkcia vracia Arraylist slov
     */
    private ArrayList<ArrayList> getPremenne() {
        return premenne;
    }
}
