package syntax;

import java.awt.*;

public class SyntaxStyle {

    Font pismo;
    int italic = 0;
    int bold = 0;
    int size = 12;

    public SyntaxStyle(String typ, int size, Color color, int italic, int bold) {
        pismo = new Font(typ, bold, size);
        this.color = color;
        this.size = size;
        this.italic = italic;
        this.bold = bold;

    }

    public Color getColor() {
        return color;
    }

    public boolean isPlain() {
        boolean pom = false;
        if (italic == 1) {
            if (bold == 1) {
                pom = true;
            }
        }
        return pom;
    }

    public boolean isItalic() {
        boolean pom = false;
        if (italic == 1) {
            pom = true;
        }
        return pom;
    }

    /**
     * Returns true if boldface is enabled for this style.
     */
    public boolean isBold() {
        boolean pom = false;
        if (bold == 1) {
            pom = true;
        }
        return pom;
    }

    /**
     * Returns the specified font, but with the style's bold and
     * italic flags applied.
     */
    public Font getStyledFont(Font font) {
        if (font == null) {
            throw new NullPointerException("font param must not"
                    + " be null");
        }
        if (font.equals(lastFont)) {
            return lastStyledFont;
        }
        lastFont = pismo;

        lastStyledFont = new Font(font.getFamily(), bold, size);


        return lastStyledFont;
    }

    /**
     * Returns the font metrics for the styled font.
     */
    public FontMetrics getFontMetrics(Font font) {
        if (font == null) {
            throw new NullPointerException("font param must not"
                    + " be null");
        }
        if (font.equals(lastFont) && fontMetrics != null) {
            return fontMetrics;
        }
        lastFont = pismo;
lastStyledFont= new Font(font.getFamily(), bold, size);
        fontMetrics = Toolkit.getDefaultToolkit().getFontMetrics( lastStyledFont);
        return fontMetrics;
    }

    public void setFont() {
    }

    public void setGraphicsFlags(Graphics gfx, Font font) {
      

        gfx.setFont(pismo);
        gfx.setColor(color);


    }
    private Color color;
    private Font lastFont;
    private Font lastStyledFont;
    private FontMetrics fontMetrics;
}
